/*81:*/
#line 3236 "conveps.web"

/*1:*/
#line 78 "conveps.web"

static char rcs_id[]
= "$Id: conveps.web,v 1.32 2009/08/20 11:24:17 lfinsto1 Exp $";



/*:1*/
#line 3237 "conveps.web"

/*6:*/
#line 312 "conveps.web"


#include "config.h"
#include <ctype.h> 
#include <getopt.h> 
#include <iomanip> 
#include <ios> 
#include <iostream> 
#include <math.h> 
#include <new> 
#include <pthread.h> 
#include <sstream> 
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include <time.h> 
#include <unistd.h> 

using namespace std;


/*:6*/
#line 3238 "conveps.web"

/*7:*/
#line 341 "conveps.web"


#define DEBUG_COMPILE 1


/*:7*/
#line 3239 "conveps.web"

/*8:*/
#line 349 "conveps.web"


typedef char Byte;
typedef Byte Signed_Byte;
typedef unsigned char Unsigned_Byte;



/*:8*/
#line 3240 "conveps.web"

/*10:*/
#line 389 "conveps.web"


const Unsigned_Byte MAX_FILENAME= 32;
const unsigned short MAX_SYSTEM_STRING= 1024;
const unsigned short MAX_TEX_FILE_HEADER= 1024;
const unsigned short MAX_DATESTAMP= 128;
const unsigned short MAX_BORDER_STRING= 128;

const unsigned short DEFAULT_BORDER_VALUE= 0;
const unsigned short DEFAULT_END_VALUE= 100;

const unsigned short MAX_COLOR_STRING= 128;
const unsigned short MAX_ZEROES_STRING= 16;

const unsigned short DEFAULT_ZEROES= 2;

const unsigned short MAX_COERCE_STRING= 32;
const unsigned short MAX_OUTPUT_EXTENSION= 8;


const unsigned short DEFAULT_THREADS_LIMIT= 100;

const Unsigned_Byte SILENT= 0;
const Unsigned_Byte QUIET= 1;
const Unsigned_Byte NORMAL= 2;
const Unsigned_Byte VERBOSE= 3;

const Unsigned_Byte PORTRAIT= 0;
const Unsigned_Byte LANDSCAPE= 1;






/*:10*/
#line 3241 "conveps.web"

/*9:*/
#line 364 "conveps.web"


struct
Thread_Func_Arg_Type
{
int eps_file_number;
int thread_ctr;
char zeroes_string[MAX_ZEROES_STRING];

};




/*:9*/
#line 3242 "conveps.web"

/*11:*/
#line 441 "conveps.web"


Unsigned_Byte VERBOSITY;

char filename_stem[MAX_FILENAME];
char new_filename_stem[MAX_FILENAME];

int start_value= -1;
int end_value= -1;

char border_string[MAX_BORDER_STRING];
char vertical_border_string[MAX_BORDER_STRING];
char horizontal_border_string[MAX_BORDER_STRING];
char default_border_string[MAX_BORDER_STRING];

char border_color_string[MAX_COLOR_STRING];
char default_border_color_string[MAX_COLOR_STRING];

Unsigned_Byte eps_output= 0;
Unsigned_Byte jpeg_output= 0;
Unsigned_Byte pnm_output= 0;
Unsigned_Byte png_output= 0;
Unsigned_Byte ps_output= 0;

Unsigned_Byte*default_output= 0;

bool force_switch= false;

char fill_string[MAX_COLOR_STRING];
char opaque_string[MAX_COLOR_STRING];
char transparent_string[MAX_COLOR_STRING];
char negate_string[16]= "";

signed int zeroes= -1;


unsigned int height_value= 0;
unsigned int width_value= 0;

unsigned int renumber_value= 0;

Unsigned_Byte coerce_value= 0;
Unsigned_Byte portrait_or_landscape= PORTRAIT;



char coerce_string[MAX_COERCE_STRING];
char output_extension[MAX_OUTPUT_EXTENSION];

pthread_t*thread_array[8192];

Thread_Func_Arg_Type*thread_func_args[8192];

pthread_mutex_t stdio_mutex;

unsigned short threads_limit= DEFAULT_THREADS_LIMIT;

char tex_file_header[MAX_TEX_FILE_HEADER];


/*:11*/
#line 3243 "conveps.web"

/*63:*/
#line 2417 "conveps.web"

void*
thread_func(void*v);



/*:63*/
#line 3244 "conveps.web"

/*50:*/
#line 1790 "conveps.web"


int
main(int argc,char**argv)
{

VERBOSITY= NORMAL;

/*12:*/
#line 509 "conveps.web"


bool DEBUG= false;

int status;

char zeroes_string[MAX_ZEROES_STRING];


/*:12*/
#line 1798 "conveps.web"


/*14:*/
#line 536 "conveps.web"


int option_ctr;
int digit_optind= 0;

const unsigned short BORDER_INDEX= 0;
const unsigned short BORDER_COLOR_INDEX= 1;
const unsigned short COERCE_INDEX= 2;
const unsigned short END_INDEX= 3;
const unsigned short FILL_INDEX= 4;
const unsigned short FORCE_INDEX= 5;
const unsigned short GRAY_NEGATE_INDEX= 6;
const unsigned short HEIGHT_INDEX= 7;
const unsigned short HELP_INDEX= 8;
const unsigned short HORIZONTAL_BORDER_INDEX= 9;
const unsigned short LANDSCAPE_INDEX= 10;
const unsigned short NEGATE_INDEX= 11;
const unsigned short NEW_FILENAME_INDEX= 12;
const unsigned short NO_ZEROES_INDEX= 13;
const unsigned short OPAQUE_INDEX= 14;
const unsigned short OUTPUT_FORMAT_INDEX= 15;
const unsigned short PORTRAIT_INDEX= 16;
const unsigned short QUIET_INDEX= 17;
const unsigned short RENUMBER_INDEX= 18;
const unsigned short SILENT_INDEX= 19;
const unsigned short START_INDEX= 20;
const unsigned short THREADS_LIMIT_INDEX= 21;
const unsigned short TRANSPARENT_INDEX= 22;
const unsigned short VERBOSE_INDEX= 23;
const unsigned short VERSION_INDEX= 24;
const unsigned short VERTICAL_BORDER_INDEX= 25;
const unsigned short WIDTH_INDEX= 26;
const unsigned short ZEROES_INDEX= 27;

static struct option long_options[]= {
{"border",2,0,0},
{"bordercolor",1,0,0},
{"coerce",2,0,0},
{"end",1,0,0},
{"fill",1,0,0},
{"force",0,0,0},
{"gray-negate",0,0,0},
{"height",1,0,0},
{"help",0,0,0},
{"horizontal-border",2,0,0},
{"landscape",0,0,0},
{"negate",0,0,0},
{"new-filename",1,0,0},
{"no-zeroes",0,0,0},
{"opaque",1,0,0},
{"output-format",1,0,0},
{"portrait",0,0,0},
{"quiet",0,0,0},
{"renumber",1,0,0},
{"silent",0,0,0},
{"start",1,0,0},
{"threads-limit",1,0,0},
{"transparent",1,0,0},
{"verbose",0,0,0},
{"version",0,0,0},
{"vertical-border",2,0,0},
{"width",1,0,0},
{"zeroes",1,0,0},
{0,0,0,0}
};

int option_index= 0;
int this_option_optind= optind?optind:1;



/*:14*/
#line 1800 "conveps.web"


pthread_mutex_init(&stdio_mutex,0);

strcpy(border_string,"");
strcpy(horizontal_border_string,"");
strcpy(vertical_border_string,"");

sprintf(default_border_string,"%d",DEFAULT_BORDER_VALUE);

strcpy(border_color_string,"");
strcpy(default_border_color_string,"white");

strcpy(fill_string,"");
strcpy(opaque_string,"");
strcpy(transparent_string,"");

strcpy(new_filename_stem,"");


/*:50*//*51:*/
#line 1833 "conveps.web"


char*default_output_env_var;

default_output_env_var= getenv("CONVEPS_DEFAULT_OUTPUT_FORMAT");

if(!default_output_env_var||!strlen(default_output_env_var))
default_output= &png_output;

else if(!(strncasecmp(default_output_env_var,"eps",10)))
default_output= &eps_output;

else if(!(strncasecmp(default_output_env_var,"jpeg",10)))
default_output= &jpeg_output;

else if(!(strncasecmp(default_output_env_var,"jpg",10)))
default_output= &jpeg_output;

else if(!(strncasecmp(default_output_env_var,"pnm",10)))
default_output= &pnm_output;

else if(!(strncasecmp(default_output_env_var,"png",10)))
default_output= &png_output;

else if(!(strncasecmp(default_output_env_var,"ps",10)))
default_output= &ps_output;

else
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"WARNING!  In `main()':  The environment variable "
<<"`CONVEPS_DEFAULT_OUTPUT_FORMAT'"
<<endl
<<"has invalid value:  "
<<default_output_env_var
<<endl
<<"Will use PNG format instead."
<<endl;
cerr<<"Type <RETURN> to continue: ";
getchar();
pthread_mutex_unlock(&stdio_mutex);

default_output= &png_output;
}

*default_output= 2;

default_output_env_var= 0;

/*15:*/
#line 616 "conveps.web"


DEBUG= false;;

while(1)
{


option_ctr= getopt_long_only(argc,argv,"cefghlnopqrstvwz",
long_options,&option_index);



if(option_ctr==-1)
{
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"No more option arguments."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}

break;
}



if(option_ctr==0)
{
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"option "<<long_options[option_index].name;
if(optarg)
cerr<<" with arg "<<optarg<<endl;
else
cerr<<" with no arguments"<<endl;
cerr<<"`option_index' == "<<option_index<<endl;
pthread_mutex_unlock(&stdio_mutex);
}



/*:15*//*16:*/
#line 667 "conveps.web"


if(option_index==BORDER_INDEX)
{

if(optarg)
strcpy(border_string,optarg);

else
sprintf(border_string,"%d",DEFAULT_BORDER_VALUE);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting border_string to %s.\n",
border_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}


/*:16*//*17:*/
#line 699 "conveps.web"


else if(option_index==BORDER_COLOR_INDEX)
{


sprintf(border_color_string,"%s",
optarg);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting border_color_string to %s.\n",
border_color_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}




/*:17*//*18:*/
#line 731 "conveps.web"


else if(option_index==COERCE_INDEX)
{

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Coercing.");
if(optarg)
fprintf(stderr,"'optarg' == %s\n",optarg);
else
fprintf(stderr,"'optarg' == 0\n");
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



if(optarg&&!strcasecmp(optarg,"s"))
{
#if DEBUG_COMPILE
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Coercing to 320x240 pixels\n");
pthread_mutex_unlock(&stdio_mutex);

#endif 


coerce_value= 1;
}




else if(optarg&&!strcasecmp(optarg,"l"))
{
#if DEBUG_COMPILE

pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Coercing to 640x480 pixels\n");
pthread_mutex_unlock(&stdio_mutex);

#endif 


coerce_value= 2;
}





else if(optarg)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"WARNING!  Invalid argument for the '--coerce'\
option:  %s\nWill coerce to 640x480 pixels.\n",optarg);
pthread_mutex_unlock(&stdio_mutex);

coerce_value= 2;
}



else
{
#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"`optarg' == 0.  "
<<"Coercing to 640x480 pixels"<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

coerce_value= 2;

}



}




/*:18*//*19:*/
#line 831 "conveps.web"


else if(option_index==END_INDEX)
{

sscanf(optarg,"%d",&end_value);
force_switch= true;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting end_value to %d.\n",
end_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}




/*:19*//*20:*/
#line 862 "conveps.web"


else if(option_index==FILL_INDEX)
{

sprintf(fill_string,"-fill \"%s\"",optarg);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting `fill_string' to %s.\n",
fill_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:20*//*21:*/
#line 891 "conveps.web"


else if(option_index==FORCE_INDEX)
{

force_switch= true;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Setting `force_switch' to "<<force_switch
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}


/*:21*//*22:*/
#line 919 "conveps.web"


else if(option_index==GRAY_NEGATE_INDEX)
{

strcpy(negate_string,"+negate");

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting `negate_string' to %s.\n",
negate_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}


/*:22*//*23:*/
#line 947 "conveps.web"


else if(option_index==HEIGHT_INDEX)
{


sscanf(optarg,"%d",&height_value);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting height to %d pixels.\n",height_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:23*//*24:*/
#line 971 "conveps.web"


else if(option_index==HELP_INDEX)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,
"conveps.\nCopyright (C) 2012 The Free Software Foundation\n");
pthread_mutex_unlock(&stdio_mutex);

exit(0);

}


/*:24*//*25:*/
#line 993 "conveps.web"


else if(option_index==HORIZONTAL_BORDER_INDEX)
{

if(optarg)
strcpy(horizontal_border_string,optarg);

else
sprintf(horizontal_border_string,"%d",
DEFAULT_BORDER_VALUE);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting horizontal border_string to %s.\n",
horizontal_border_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:25*//*26:*/
#line 1027 "conveps.web"


else if(option_index==LANDSCAPE_INDEX)
{
portrait_or_landscape= LANDSCAPE;

}




/*:26*//*27:*/
#line 1046 "conveps.web"


else if(option_index==NEGATE_INDEX)
{

strcpy(negate_string,"-negate");

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting `negate_string' to %s.\n",
negate_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}


/*:27*//*28:*/
#line 1074 "conveps.web"


else if(option_index==NEW_FILENAME_INDEX)
{


sscanf(optarg,"%s",&new_filename_stem);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting new filename stem to `%s'.\n",
new_filename_stem);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}






/*:28*//*29:*/
#line 1107 "conveps.web"


else if(option_index==NO_ZEROES_INDEX)
{

zeroes= 0;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting `zeroes' to %d.\n",
zeroes);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}




/*:29*//*30:*/
#line 1137 "conveps.web"


else if(option_index==OPAQUE_INDEX)
{

sprintf(opaque_string,"-opaque \"%s\"",optarg);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting `opaque_string' to %s.\n",
opaque_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:30*//*31:*/
#line 1170 "conveps.web"


else if(option_index==OUTPUT_FORMAT_INDEX)
{



if(!strcasecmp(optarg,"eps"))
{

eps_output= 1;
*default_output%= 2;
}



else if(!strcasecmp(optarg,"jpeg")
||!strcasecmp(optarg,"jpg"))

{

jpeg_output= 1;
*default_output%= 2;
}



else if(!strcasecmp(optarg,"png"))
{

png_output= 1;
*default_output%= 2;
}



else if(!strcasecmp(optarg,"pnm"))
{
pnm_output= 1;
*default_output%= 2;
}




else if(!strcasecmp(optarg,"ps"))
{
ps_output= 1;
*default_output%= 2;
}



else
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"WARNING!  Invalid `-output-format' argument:\
%s\nIgnoring.\n",optarg);
pthread_mutex_unlock(&stdio_mutex);
}




}



/*:31*//*32:*/
#line 1246 "conveps.web"


else if(option_index==PORTRAIT_INDEX)
{
portrait_or_landscape= PORTRAIT;

}



/*:32*//*33:*/
#line 1258 "conveps.web"


else if(option_index==QUIET_INDEX)
{

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Will run quietly.\n");
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

VERBOSITY= QUIET;

}



/*:33*//*34:*/
#line 1289 "conveps.web"


else if(option_index==RENUMBER_INDEX)
{


sscanf(optarg,"%d",&renumber_value);
--renumber_value;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Renumbering starting with %d.\n",
renumber_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:34*//*35:*/
#line 1314 "conveps.web"


else if(option_index==SILENT_INDEX)
{
#if DEBUG_COMPILE
if(DEBUG)
{
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Will run silently.\n");
pthread_mutex_unlock(&stdio_mutex);
}

}
#endif 

VERBOSITY= SILENT;

}



/*:35*//*36:*/
#line 1345 "conveps.web"


else if(option_index==START_INDEX)
{

sscanf(optarg,"%d",&start_value);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting start_value to %d.\n",
start_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:36*//*37:*/
#line 1374 "conveps.web"


else if(option_index==THREADS_LIMIT_INDEX)
{

sscanf(optarg,"%d",&threads_limit);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting threads_limit to %d.\n",
threads_limit);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:37*//*38:*/
#line 1403 "conveps.web"


else if(option_index==TRANSPARENT_INDEX)
{

sprintf(transparent_string,"-transparent \"%s\"",optarg);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting `transparent_string' to %s.\n",
transparent_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:38*//*39:*/
#line 1425 "conveps.web"


else if(option_index==VERBOSE_INDEX)
{
#if DEBUG_COMPILE
if(DEBUG)
{
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Will run verbosely.\n");
pthread_mutex_unlock(&stdio_mutex);
}

}
#endif 

VERBOSITY= VERBOSE;

}


/*:39*//*40:*/
#line 1449 "conveps.web"


else if(option_index==VERSION_INDEX)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"conveps 1.2.0\n");
pthread_mutex_unlock(&stdio_mutex);

exit(0);
}



/*:40*//*41:*/
#line 1470 "conveps.web"


else if(option_index==VERTICAL_BORDER_INDEX)
{

if(optarg)
strcpy(vertical_border_string,optarg);

else
sprintf(vertical_border_string,"%d",
DEFAULT_BORDER_VALUE);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting vertical border_string to %s.\n",
vertical_border_string);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:41*//*42:*/
#line 1504 "conveps.web"


else if(option_index==WIDTH_INDEX)
{


sscanf(optarg,"%d",&width_value);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting width to %d pixels.\n",width_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:42*//*43:*/
#line 1533 "conveps.web"


else if(option_index==ZEROES_INDEX)
{

sscanf(optarg,"%d",&zeroes);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Setting `zeroes' to %d.\n",
zeroes);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}



/*:43*//*44:*/
#line 1556 "conveps.web"


else
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"ERROR!  In `main()':\n`option_index' has invalid value: %d\n\
Will try to continue.\n",option_index);
pthread_mutex_unlock(&stdio_mutex);
}



}


/*:44*//*45:*/
#line 1573 "conveps.web"


else if(option_ctr=='?')
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"ERROR!  In `main()':  `getopt_long()' returned "
<<"ambiguous match. Breaking."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}


/*:45*//*46:*/
#line 1586 "conveps.web"


else
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"getopt_long() returned invalid option.\n");
pthread_mutex_unlock(&stdio_mutex);
}


/*:46*//*47:*/
#line 1598 "conveps.web"



}


if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"In `main()':  End of command line processing.\n");
pthread_mutex_unlock(&stdio_mutex);
}



/*:47*/
#line 1882 "conveps.web"



/*:51*//*52:*/
#line 1886 "conveps.web"


if(VERBOSITY>=NORMAL)
{
cerr<<"conveps Version 1.2.0"
<<endl
<<"conveps is part of GNU 3DLDF Version 1.2.0"
<<endl
<<"Copyright (C) 2012 The Free Software Foundation"
<<endl
<<"Author:  Laurence D. Finston"
<<endl
<<"conveps and GNU 3DLDF come with ABSOLUTELY NO WARRANTY;"
<<endl
<<"for details see the file COPYING,"
<<endl
<<"which you should have received"
<<endl
<<"in the distribution of GNU 3DLDF 1.2.0."
<<endl
<<"This is Free Software, and you are welcome"
<<endl
<<"to redistribute it under certain conditions;"
<<endl
<<"for details, again, see the file COPYING."
<<endl<<endl
<<"Please send bug reports to Laurence.Finston@gmx.de"
<<endl
<<"Web site:  http://www.gnu.org/software/3dldf/LDF.html"
<<endl<<endl;

}



/*:52*//*53:*/
#line 1929 "conveps.web"


{

stringstream tex_stringstream;

tex_stringstream<<"\\batchmode\\input epsf"
<<endl
<<"\\def\\epsfsize#1#2{#1}"
<<endl
<<"\\nopagenumbers"
<<endl
<<"\\parindent=0pt"
<<endl;
#if 0 
if(portrait_or_landscape==LANDSCAPE)
tex_stringstream<<"\\hsize=420mm"
<<endl
<<"\\vsize=297mm"
<<endl
<<"\\special{papersize=420mm, 297mm}"
<<endl;

else
tex_stringstream<<"\\hsize=297mm"
<<endl
<<"\\vsize=420mm"
<<endl;
#endif


tex_stringstream<<"\\advance\\voffset by -1in"
<<endl
<<"\\advance\\hoffset by -1in"
<<endl;


strcpy(tex_file_header,tex_stringstream.str().c_str());

}





/*:53*//*54:*/
#line 1975 "conveps.web"


if(!(strlen(border_string)==0
&&strlen(horizontal_border_string)==0
&&strlen(vertical_border_string)==0))
{
if(strlen(horizontal_border_string)==0)
strcpy(horizontal_border_string,border_string);

if(strlen(vertical_border_string)==0)
strcpy(vertical_border_string,border_string);

if(strlen(border_color_string)==0)
strcpy(border_color_string,default_border_color_string);


sprintf(border_string,"-border %sx%s -bordercolor %s",
horizontal_border_string,vertical_border_string,
border_color_string);

}




if(!(eps_output||jpeg_output||png_output||pnm_output||ps_output))
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"ERROR!  Command line arguments suppress all output.\n\
Exiting `conveps' with return value 1.\n");
pthread_mutex_unlock(&stdio_mutex);

return 1;
}

/*48:*/
#line 1622 "conveps.web"


Unsigned_Byte arg_ctr= optind;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"arg_ctr == %d\nargc == %d\n",arg_ctr,argc);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



if(argc-arg_ctr<1)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"ERROR!  In `main()':  Not enough arguments.\n\
Exiting `conveps' with return value 1.\n");
pthread_mutex_unlock(&stdio_mutex);

return 1;

}




if(argc-arg_ctr>=1)
strcpy(filename_stem,argv[arg_ctr]);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"filename_stem == %s\n",filename_stem);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 






++arg_ctr;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Before start value arg:  arg_ctr == %d\n",arg_ctr);
fprintf(stderr,"Before start value arg:  start_value == %d\n",start_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


if(argc-arg_ctr>=1&&start_value!=-1)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"WARNING:  `start_value' already set using an optional argument.\n\
`start_value' == %d.  Not resetting to %s\n",start_value,argv[arg_ctr]);
pthread_mutex_unlock(&stdio_mutex);

}



else if(argc-arg_ctr>=1&&start_value==-1)
sscanf(argv[arg_ctr],"%d",&start_value);



else if(start_value==-1)
start_value= 0;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"After start value arg:  arg_ctr == %d\n",arg_ctr);
fprintf(stderr,"After start value arg:  start_value == %d\n",start_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 






++arg_ctr;





#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Before end value arg:  arg_ctr == %d\n",arg_ctr);
fprintf(stderr,"Before end value arg:  end_value == %d\n",end_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



if(argc-arg_ctr>=1&&end_value!=-1)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"WARNING:  `end_value' already set using an optional argument.\n\
`end_value' == %d.  Not resetting to %s\n",end_value,argv[arg_ctr]);
pthread_mutex_unlock(&stdio_mutex);

}


/*:48*//*49:*/
#line 1752 "conveps.web"


else if(argc-arg_ctr>=1&&end_value==-1)
{
sscanf(argv[arg_ctr],"%d",&end_value);
force_switch= true;
}



else if(end_value==-1)
end_value= DEFAULT_END_VALUE;

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"After end value arg:  arg_ctr == %d\n",arg_ctr);
fprintf(stderr,"After end value arg:  end_value == %d\n",end_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 






++arg_ctr;




/*:49*/
#line 2010 "conveps.web"



#if DEBUG_COMPILE

if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"`filename_stem': %s\n",filename_stem);

fprintf(stderr,"`start_value': %d\n",start_value);
fprintf(stderr,"`end_value': %d\n",end_value);

if(strlen(horizontal_border_string))
fprintf(stderr,"`horizontal_border_string': %s\n",
horizontal_border_string);
else
fprintf(stderr,"`horizontal_border_string' is empty.\n");

if(strlen(vertical_border_string))
fprintf(stderr,"`vertical_border_string': %s\n",
vertical_border_string);
else
fprintf(stderr,"`vertical_border_string' is empty.\n");

if(strlen(border_string))
fprintf(stderr,"`border_string': %s\n",
border_string);
else
fprintf(stderr,"`border_string' is empty.\n");

if(eps_output)
fprintf(stderr,"Producing EPS output.\n");
else
fprintf(stderr,"Not producing EPS output.\n");

if(jpeg_output)
fprintf(stderr,"Producing JPEG output.\n");
else
fprintf(stderr,"Not producing JPEG output.\n");

if(png_output)
fprintf(stderr,"Producing PNG output.\n");
else
fprintf(stderr,"Not producing PNG output.\n");

if(pnm_output)
fprintf(stderr,"Producing PNM output.\n");
else
fprintf(stderr,"Not producing PNM output.\n");

if(ps_output)
fprintf(stderr,"Producing PS output.\n");
else
fprintf(stderr,"Not producing PS output.\n");

pthread_mutex_unlock(&stdio_mutex);

}

#endif 




/*:54*//*55:*/
#line 2089 "conveps.web"


int i;

float width;
float height;


/*:55*//*56:*/
#line 2114 "conveps.web"


if(zeroes==0)
zeroes_string[0]= '\0';

else if((end_value+renumber_value)> 10000)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,
"ERROR!  (`end_value' + `renumber_value') == %d > 10,000.\n\
Can't handle this case yet.\nExiting `conveps' with return value 1.\n",
end_value+renumber_value);
pthread_mutex_unlock(&stdio_mutex);

return 1;

}

else if((end_value+renumber_value)>=1000&&zeroes<=4)
{
zeroes= 4;
}

else if((end_value+renumber_value)>=100&&zeroes<=3)
{
zeroes= 3;
}

else if((end_value+renumber_value)>=10&&zeroes<=2)
{
zeroes= 2;
}

else if(zeroes<0)
{
zeroes= DEFAULT_ZEROES;
}


#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"zeroes == "<<zeroes<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



{
int i;
for(i= 0;i<zeroes;++i)
zeroes_string[i]= '0';
zeroes_string[i]= '\0';
}


#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"zeroes_string == "<<zeroes_string<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 




/*:56*//*57:*/
#line 2192 "conveps.web"



#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,
"start_value == %d, end_value == %d, renumber_value == %d\n",
start_value,end_value,renumber_value);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


int thread_ctr= 0;

char temp_eps_file_name[MAX_FILENAME];
FILE*temp_eps_file;



/*:57*//*58:*/
#line 2224 "conveps.web"


{

int i= start_value;

for(int k= 0;;++k)
{

if(i> end_value)
break;

for(i= start_value+(k*threads_limit);
i<start_value+(k*threads_limit)+threads_limit;
++i)
{


/*:58*//*59:*/
#line 2243 "conveps.web"


if(i> end_value)
break;

sprintf(temp_eps_file_name,"%s.%d",filename_stem,i);

if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"`temp_eps_file_name' == "
<<"`"<<temp_eps_file_name<<"'."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}

temp_eps_file= fopen(temp_eps_file_name,"r");


/*:59*//*60:*/
#line 2266 "conveps.web"


if(temp_eps_file==0&&(force_switch||i==0))
{

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<filename_stem<<"."<<i
<<"doesn't exist.  Continuing."
<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

continue;
}


/*:60*//*61:*/
#line 2292 "conveps.web"

else if(temp_eps_file==0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<filename_stem<<"."<<i<<" doesn't exist.  "
<<"Won't create any more threads."<<endl;
pthread_mutex_unlock(&stdio_mutex);

i= end_value+1;
break;
}


else
fclose(temp_eps_file);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"About to create thread."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

thread_array[thread_ctr]= (pthread_t*)malloc(sizeof(pthread_t));

thread_func_args[thread_ctr]= new Thread_Func_Arg_Type;
thread_func_args[thread_ctr]->eps_file_number= i;
thread_func_args[thread_ctr]->thread_ctr= thread_ctr;
strcpy(thread_func_args[thread_ctr]->zeroes_string,zeroes_string);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"zeroes_string == "<<zeroes_string<<endl;
cerr<<"thread_func_args["<<thread_ctr<<"]->zeroes_string  == "
<<thread_func_args[thread_ctr]->zeroes_string
<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

do{

status= pthread_create(thread_array[thread_ctr],0,
thread_func,thread_func_args[thread_ctr]);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"ERROR!  In `main()':\n"
<<"`pthread_create()' failed, returning "<<status
<<"."<<endl<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"After creating thread."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

++thread_ctr;

}




for(int j= 0+(k*threads_limit);j<thread_ctr;++j)
{

pthread_join(*(thread_array[j]),0);

if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Joined with thread %d.\n",j);
pthread_mutex_unlock(&stdio_mutex);
}

}

}

}




/*:61*//*62:*/
#line 2397 "conveps.web"


if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Exiting `conveps' successfully with return value 0.\n");
pthread_mutex_unlock(&stdio_mutex);
}


return 0;

}



/*:62*/
#line 3245 "conveps.web"

/*78:*/
#line 3215 "conveps.web"





/*:78*/
#line 3246 "conveps.web"

/*79:*/
#line 3226 "conveps.web"






/*:79*/
#line 3247 "conveps.web"

/*64:*/
#line 2424 "conveps.web"

void*
thread_func(void*v)
{



bool DEBUG= false;

char system_string[MAX_SYSTEM_STRING];

char out_filename_stem[MAX_FILENAME];

if(strlen(new_filename_stem))
strcpy(out_filename_stem,new_filename_stem);
else
strcpy(out_filename_stem,filename_stem);

int status;

Thread_Func_Arg_Type*arg_ptr= (Thread_Func_Arg_Type*)v;

int i= arg_ptr->eps_file_number;
int thread_ctr= arg_ptr->thread_ctr;


/*:64*//*65:*/
#line 2457 "conveps.web"


FILE*tex_file;
FILE*dvi_file;
FILE*eps_file;
FILE*ps_file;

char temp_file_name[MAX_FILENAME];
char tex_file_name[MAX_FILENAME];
char dvi_file_name[MAX_FILENAME];
char ps_file_name[MAX_FILENAME];
char pnm_file_name[MAX_FILENAME];
char eps_file_name[MAX_FILENAME];
char log_file_name[MAX_FILENAME];

int width_pixels= 0;
int height_pixels= 0;

float width_cm= 0;
float height_cm= 0;


/*:65*//*66:*/
#line 2480 "conveps.web"


#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Entering `thread_func()'.\n",thread_ctr);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 





/*:66*//*67:*/
#line 2502 "conveps.web"



int temp_ctr= zeroes;

if((i+renumber_value)<10)
temp_ctr-= 1;

else if((i+renumber_value)<100)
temp_ctr-= 2;

else if((i+renumber_value)<1000)
temp_ctr-= 3;

else
temp_ctr= 0;


#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"temp_ctr == "<<temp_ctr
<<endl
<<"Before:  arg_ptr->zeroes_string  == "
<<arg_ptr->zeroes_string
<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


arg_ptr->zeroes_string[temp_ctr]= '\0';


#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"After:  arg_ptr->zeroes_string  == "
<<arg_ptr->zeroes_string
<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 





#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  `arg_ptr->zeroes_string' == "
<<arg_ptr->zeroes_string<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


/*:67*//*68:*/
#line 2574 "conveps.web"


sprintf(eps_file_name,"%s.%d",filename_stem,
i);

sprintf(tex_file_name,"%s_%s%d.tex",out_filename_stem,
arg_ptr->zeroes_string,(i+renumber_value));

sprintf(dvi_file_name,"%s_%s%d.dvi",out_filename_stem,
arg_ptr->zeroes_string,(i+renumber_value));

sprintf(log_file_name,"%s_%s%d.log",out_filename_stem,
arg_ptr->zeroes_string,(i+renumber_value));

sprintf(ps_file_name,"%s_%s%d.ps",out_filename_stem,
arg_ptr->zeroes_string,(i+renumber_value));

sprintf(pnm_file_name,"%s_%s%d.pnm",out_filename_stem,
arg_ptr->zeroes_string,(i+renumber_value));

tex_file= fopen(tex_file_name,"w");

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  `eps_file_name' == %s\n",
thread_ctr,eps_file_name);
fprintf(stderr,"Thread %d:  `tex_file_name' == %s\n",
thread_ctr,tex_file_name);
fprintf(stderr,"Thread %d:  `dvi_file_name' == %s\n",
thread_ctr,dvi_file_name);
fprintf(stderr,"Thread %d:  `log_file_name' == %s\n",
thread_ctr,log_file_name);
fprintf(stderr,"Thread %d:  `ps_file_name' == %s\n",
thread_ctr,ps_file_name);
fprintf(stderr,"Thread %d:  `pnm_file_name' == %s\n",
thread_ctr,pnm_file_name);
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


/*:68*//*69:*/
#line 2627 "conveps.web"


strcpy(system_string,"identify ");
strcat(system_string,eps_file_name);

FILE*fp= popen(system_string,"r");










fscanf(fp,"%*s %*s %dx%d",&width_pixels,&height_pixels);

pclose(fp);

fp= 0;

width_cm= width_pixels/29.0;
height_cm= height_pixels/29.0;

strcpy(system_string,"");

fprintf(tex_file,"%s\n\\setbox0=\\vbox{\\hbox{\\epsffile{%s}\
\\hskip5pt}\\vskip5pt}\n\
\\vsize=\\ht0\n\\hsize=\\wd0\n\
\\special{papersize=%.3fcm, %.3fcm}\n\n\
\\box0\n\\bye\n",
tex_file_header,
eps_file_name,
width_cm,
height_cm);

fclose(tex_file);

sprintf(system_string,"tex %s > /dev/null",tex_file_name);

if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Executing `%s'.\n",
thread_ctr,system_string);
pthread_mutex_unlock(&stdio_mutex);
}

do{

status= system(system_string);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  ERROR!  In `thread_func':\n"
<<"`system()' failed, returning "<<status
<<"."<<endl<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);

if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  `"
<<system_string<<"' returned "
<<status
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}


/*:69*//*70:*/
#line 2718 "conveps.web"



sprintf(system_string,"rm -f %s",ps_file_name);

if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  Executing `"
<<system_string<<"'."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}

status= system(system_string);

if(status!=0&&VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  WARNING!  In `thread_func':\n"
<<"Failed to delete `"<<ps_file_name<<"'."
<<"  Continuing."<<endl;
pthread_mutex_unlock(&stdio_mutex);

}

sprintf(system_string,"dvips -q -o %s %s",
ps_file_name,dvi_file_name);

if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Executing `%s'.\n",
thread_ctr,system_string);
pthread_mutex_unlock(&stdio_mutex);
}

do{

status= system(system_string);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  ERROR!  In `thread_func':\n"
<<"`system()' failed, returning "<<status
<<"."<<endl
<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  `"
<<system_string<<"' returned "
<<status
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


/*:70*//*71:*/
#line 2802 "conveps.web"


sprintf(system_string,
"mogrify +antialias -crop %dx%d %s",
width_pixels,height_pixels,ps_file_name);


if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  Executing `"
<<system_string<<"'."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}

status= system(system_string);


/*:71*//*72:*/
#line 2835 "conveps.web"


#if 0 

if(portrait_or_landscape==LANDSCAPE)
{
sprintf(system_string,
"mogrify +antialias -rotate -90 %s",ps_file_name);


if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  Executing `"
<<system_string<<"'."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}

status= system(system_string);

}
#endif




if(coerce_value==0)
strcpy(coerce_string,"");

else if(coerce_value==1)
strcpy(coerce_string,"-geometry 320x240!");

else if(coerce_value==2)
strcpy(coerce_string,"-geometry 640x480!");

else
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,
"Thread %d:  ERROR!  In `main()':  Invalid value for \
`coerce_value':  %d\nSetting `coerce_string' to \"\" and continuing.\n",
thread_ctr,coerce_value);
pthread_mutex_unlock(&stdio_mutex);

strcpy(coerce_string,"");
}


/*:72*//*73:*/
#line 2891 "conveps.web"



if(strlen(coerce_string)
||strlen(opaque_string)
||strlen(border_string)
||strlen(negate_string)
)
{

sprintf(system_string,
"mogrify +antialias %s %s %s %s %s %s",
border_string,
fill_string,opaque_string,
coerce_string,
negate_string,
ps_file_name);


if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  Executing `"
<<system_string<<"'."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}


do{

status= system(system_string);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  ERROR!  In `thread_func':\n"
<<"`system()' failed, returning "<<status
<<"."<<endl<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);



#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  `"<<system_string
<<"' returned "<<status
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 

}




/*:73*//*74:*/
#line 2980 "conveps.web"


if(eps_output)
{
strcpy(output_extension,"eps");
/*75:*/
#line 3062 "conveps.web"


sprintf(system_string,"convert +antialias %s %s %s %s_%s%d.%s",
transparent_string,coerce_string,
ps_file_name,
out_filename_stem,arg_ptr->zeroes_string,(i+renumber_value),
output_extension);

if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Executing `%s'.\n",
thread_ctr,system_string);
pthread_mutex_unlock(&stdio_mutex);
}

do{

status= system(system_string);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  ERROR!  In `thread_func':\n"
<<"`system()' failed, returning "<<status
<<"."<<endl<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  `"<<system_string<<"' returned "<<status
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



/*:75*/
#line 2985 "conveps.web"

}

if(jpeg_output)
{
strcpy(output_extension,"jpg");
/*75:*/
#line 3062 "conveps.web"


sprintf(system_string,"convert +antialias %s %s %s %s_%s%d.%s",
transparent_string,coerce_string,
ps_file_name,
out_filename_stem,arg_ptr->zeroes_string,(i+renumber_value),
output_extension);

if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Executing `%s'.\n",
thread_ctr,system_string);
pthread_mutex_unlock(&stdio_mutex);
}

do{

status= system(system_string);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  ERROR!  In `thread_func':\n"
<<"`system()' failed, returning "<<status
<<"."<<endl<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  `"<<system_string<<"' returned "<<status
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



/*:75*/
#line 2991 "conveps.web"

}


if(pnm_output)
{
strcpy(output_extension,"pnm");
/*75:*/
#line 3062 "conveps.web"


sprintf(system_string,"convert +antialias %s %s %s %s_%s%d.%s",
transparent_string,coerce_string,
ps_file_name,
out_filename_stem,arg_ptr->zeroes_string,(i+renumber_value),
output_extension);

if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Executing `%s'.\n",
thread_ctr,system_string);
pthread_mutex_unlock(&stdio_mutex);
}

do{

status= system(system_string);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  ERROR!  In `thread_func':\n"
<<"`system()' failed, returning "<<status
<<"."<<endl<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  `"<<system_string<<"' returned "<<status
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



/*:75*/
#line 2998 "conveps.web"

}


if(png_output)
{
strcpy(output_extension,"png");
/*75:*/
#line 3062 "conveps.web"


sprintf(system_string,"convert +antialias %s %s %s %s_%s%d.%s",
transparent_string,coerce_string,
ps_file_name,
out_filename_stem,arg_ptr->zeroes_string,(i+renumber_value),
output_extension);

if(VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Executing `%s'.\n",
thread_ctr,system_string);
pthread_mutex_unlock(&stdio_mutex);
}

do{

status= system(system_string);
if(status!=0)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  ERROR!  In `thread_func':\n"
<<"`system()' failed, returning "<<status
<<"."<<endl<<"Going to sleep and will retry."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

sleep(1);
}

}
while(status!=0);

#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr<<":  `"<<system_string<<"' returned "<<status
<<"."<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 



/*:75*/
#line 3005 "conveps.web"

}


if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Removing %s\n",
thread_ctr,tex_file_name);
pthread_mutex_unlock(&stdio_mutex);
}


sprintf(system_string,"rm -f %s",tex_file_name);

status= system(system_string);

if((!WIFEXITED(status)||WEXITSTATUS(status)||status)&&VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  WARNING!  In `thread_func()':"
<<endl
<<"Failed to delete `"<<tex_file_name
<<"'.  Continuing."<<endl;
pthread_mutex_unlock(&stdio_mutex);

}


if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Removing %s\n",
thread_ctr,dvi_file_name);
pthread_mutex_unlock(&stdio_mutex);
}

sprintf(system_string,"rm -f %s",dvi_file_name);

status= system(system_string);

if(status!=0&&VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  WARNING!  In `thread_func':"
<<endl
<<"Failed to delete `"<<dvi_file_name
<<"'.  Continuing."<<endl;

pthread_mutex_unlock(&stdio_mutex);

}


/*:74*//*76:*/
#line 3118 "conveps.web"


if(!ps_output)
{

if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Removing %s\n",
thread_ctr,ps_file_name);
pthread_mutex_unlock(&stdio_mutex);
}


status= remove(ps_file_name);

if(status!=0&&VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  WARNING:  Failed to remove "
<<ps_file_name<<".  Continuing."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

}


}

#if DEBUG_COMPILE
else if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  Not removing "<<ps_file_name<<"."
<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


/*:76*//*77:*/
#line 3161 "conveps.web"


if(VERBOSITY>=VERBOSE)
{
pthread_mutex_lock(&stdio_mutex);
fprintf(stderr,"Thread %d:  Removing %s\n",
thread_ctr,log_file_name);
pthread_mutex_unlock(&stdio_mutex);
}

status= remove(log_file_name);

if(status!=0&&VERBOSITY>=NORMAL)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  WARNING:  Failed to remove "
<<log_file_name<<".  Continuing."
<<endl;
pthread_mutex_unlock(&stdio_mutex);

}





#if DEBUG_COMPILE
if(DEBUG)
{
pthread_mutex_lock(&stdio_mutex);
cerr<<"Thread "<<thread_ctr
<<":  Exiting `thread_func()' successfully with return value 0."
<<endl;
pthread_mutex_unlock(&stdio_mutex);
}
#endif 


delete arg_ptr;
arg_ptr= 0;

return 0;

}



/*:77*/
#line 3248 "conveps.web"




















/*:81*/
