// testbnry.c++
// Created by Laurence Finston Sat Jan  8 13:03:08 CET 2005

/* $Id: testbnry.c++ 1717 2010-12-29 14:36:24Z lfinsto $  */

/* * (1) Copyright and License.

This file is part of GNU 3DLDF, a package for three-dimensional drawing.  
Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 The Free Software Foundation  

GNU 3DLDF is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 3 of the License, or 
(at your option) any later version.  

GNU 3DLDF is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.  

You should have received a copy of the GNU General Public License 
along with GNU 3DLDF; if not, write to the Free Software 
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

GNU 3DLDF is a GNU package.  
It is part of the GNU Project of the  
Free Software Foundation 
and is published under the GNU General Public License. 
See the website http://www.gnu.org 
for more information.   
GNU 3DLDF is available for downloading from 
http://www.gnu.org/software/3dldf/LDF.html.

Please send bug reports to Laurence.Finston@gmx.de
The mailing list help-3dldf@gnu.org is available for people to 
ask other users for help.  
The mailing list info-3dldf@gnu.org is for sending 
announcements to users. To subscribe to these mailing lists, send an 
email with ``subscribe <email-address>'' as the subject.  

The author can be contacted at: 

Laurence D. Finston 
c/o Free Software Foundation, Inc. 
51 Franklin St, Fifth Floor 
Boston, MA  02110-1301  
USA

Laurence.Finston@gmx.de

*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <iomanip>
#include <ios>
#include <iostream>
#include <iterator>
#include <sstream>   
#include <stdio.h>   
#include <stdlib.h>


#include <string> 

using namespace std;

typedef double real;

const unsigned short INT      = 0;
const unsigned short FLOAT    = 1;
const unsigned short DOUBLE   = 2;
const unsigned short REAL     = 3;
const unsigned short STRING   = 4;

const unsigned short INT_SIZE    = sizeof(int);
const unsigned short FLOAT_SIZE  = sizeof(float);
const unsigned short DOUBLE_SIZE = sizeof(double);
const unsigned short REAL_SIZE   = sizeof(real);

const unsigned int buffer_size = 12;
unsigned char* buffer;
unsigned int buffer_ctr = 0;

int
write_object(int file_descriptor,
             void* object,
             unsigned short type);

int 
read_object(int file_descriptor,
            unsigned short type,
            void* object);


int 
main (int argc, char** argv)
{

   int file;
   int status;
   int i;

   int*   int_ptr     = new int;
   float* float_ptr   = new float;
   double* double_ptr = new double;

   int* temp_int_ptr;
   unsigned char* temp_char_ptr;
   unsigned char c;


   buffer = new unsigned char[buffer_size];

   cerr << "`INT_SIZE' == " << INT_SIZE << endl;

   file = creat("bnry.fmt", 0600);

   *int_ptr = 16;
  
   temp_char_ptr = static_cast<unsigned char*>(static_cast<void*>(int_ptr)); 

   for (i = 0; i < INT_SIZE; ++i)
      {

          buffer[buffer_ctr++] = *temp_char_ptr;
          ++temp_char_ptr;
      }



   *int_ptr = 24;

   temp_char_ptr = static_cast<unsigned char*>(static_cast<void*>(int_ptr)); 

   for (i = 0; i < INT_SIZE; ++i)
      {

          buffer[buffer_ctr++] = *temp_char_ptr;
          ++temp_char_ptr;
      }



   if (buffer_ctr + FLOAT_SIZE >= buffer_size)
      {
         cerr << "Dumping `buffer'.";

         status = write(file, buffer, buffer_ctr);

         cerr << "In `main()', after dumping `buffer':  `status' == " 
              << status << endl;         
 
         buffer_ctr = 0;
         
         for (i = 0; i < buffer_size; ++i)
            buffer[i] = 0;

      }  /* |if (buffer_ctr + INT_SIZE >= buffer_size)|  */



   *float_ptr = 1.25;

   temp_char_ptr = static_cast<unsigned char*>(static_cast<void*>(float_ptr)); 

   for (i = 0; i < FLOAT_SIZE; ++i)
      {

          buffer[buffer_ctr++] = *temp_char_ptr;
          ++temp_char_ptr;
      }


   if (buffer_ctr + INT_SIZE >= buffer_size)
      {
         cerr << "Dumping `buffer'.";

         status = write(file, buffer, buffer_ctr);

         cerr << "In `main()', after dumping `buffer':  `status' == " 
              << status << endl;         
 
         buffer_ctr = 0;
         
         for (i = 0; i < buffer_size; ++i)
            buffer[i] = 0;

      }  /* |if (buffer_ctr + INT_SIZE >= buffer_size)|  */


   *int_ptr = 300;

   temp_char_ptr = static_cast<unsigned char*>(static_cast<void*>(int_ptr)); 

   for (i = 0; i < INT_SIZE; ++i)
      {

          buffer[buffer_ctr++] = *temp_char_ptr;
          ++temp_char_ptr;
      }


   status = write(file, buffer, buffer_ctr);

   cerr << "In `main()', after final write to `buffer':  `status' == " 
        << status << endl;

   close(file);

   file = open("bnry.fmt", O_RDONLY);

   int j;

   float f;

   read(file, &j, INT_SIZE);

   cerr << "In `main()', first read:  `j' == " << j << endl;


   read(file, &j, INT_SIZE);

   cerr << "In `main()', second read:  `j' == " << j << endl;



   read(file, &f, FLOAT_SIZE);

   cerr << "In `main()', third read:  `f' == " << f << endl;

   read(file, &j, INT_SIZE);

   cerr << "In `main()', fourth read:  `j' == " << j << endl;


   return 0;

} /* End of |main()| definition.  */



int
write_object(int file_descriptor,
             void* object,
             unsigned short type)
{
   int* int_ptr;
   float* float_ptr;
   real* real_ptr;
   double* double_ptr;

  /* !! START HERE:  LDF 2005.01.08.  */ 


}  /* End of |write_object| definition.  */


