;;;; utils.el
;;;; Created by Laurence D. Finston (LDF) Mo Mai  9 15:38:23 CEST 2005

;;;; $Id: utils.el 1684 2010-12-17 16:34:21Z lfinsto $

;;;; * (1) Copyright and License.

;; This file is part of GNU 3DLDF, a package for three-dimensional drawing.  
;; Copyright (C) 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 The Free Software Foundation  

;; GNU 3DLDF is free software; you can redistribute it and/or modify 
;; it under the terms of the GNU General Public License as published by 
;; the Free Software Foundation; either version 3 of the License, or 
;; (at your option) any later version.  

;; GNU 3DLDF is distributed in the hope that it will be useful, 
;; but WITHOUT ANY WARRANTY; without even the implied warranty of 
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
;; GNU General Public License for more details.  

;; You should have received a copy of the GNU General Public License 
;; along with GNU 3DLDF; if not, write to the Free Software 
;; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA 

;; GNU 3DLDF is a GNU package.  
;; It is part of the GNU Project of the  
;; Free Software Foundation 
;; and is published under the GNU General Public License. 
;; See the website http://www.gnu.org 
;; for more information.   
;; GNU 3DLDF is available for downloading from 
;; http://www.gnu.org/software/3dldf/LDF.html.

;; Please send bug reports to Laurence.Finston@gmx.de
;; The mailing list help-3dldf@gnu.org is available for people to 
;; ask other users for help.  
;; The mailing list info-3dldf@gnu.org is for sending 
;; announcements to users. To subscribe to these mailing lists, send an 
;; email with ``subscribe <email-address>'' as the subject.  

;; The author can be contacted at: 

;; Laurence D. Finston 
;; c/o Free Software Foundation, Inc. 
;; 51 Franklin St, Fifth Floor 
;; Boston, MA  02110-1301  
;; USA

;; Laurence.Finston@gmx.de


;;;; * (1) 

;;;; ** (2)

;;;; 'change-file-name':  An Emacs-Lisp defun for changing 
;;;; the names of the EPS files generated by MetaPost.
;;;;      LDF 2005.05.09.


(defun change-file-name (start-value end-value new-filename)
  (let ((temp-ctr start-value)
	(old-filename "3DLDFmp")
	command-string
	temp-ctr-string
	status
	)
  
    (while (<= temp-ctr end-value)
      (setq temp-ctr-string (number-to-string temp-ctr))
      (setq command-string (concat "mv " old-filename "."
				   temp-ctr-string
				   " " new-filename "."
				   temp-ctr-string))
      (message (concat "Executing " command-string))
      (sit-for 1)
      (setq status (shell-command command-string))
      (if (not (= status 0))
	  (read-char (concat "'" command-string  "' failed.  "
			     "Press 'Control-g' to quit."))
	)

      (setq temp-ctr (1+ temp-ctr))


      )
    )
  )

(change-file-name 1 5 "sphere_1")

(progn
  (let (i i-string (display-string "display blur_1.ps "))
    (shell-command "cnepspng 3DLDFmp 1 1 1cm 1cm")  
    (setq i 2)
    (while (<= i 5)
      (setq i-string (number-to-string i))
      (shell-command (concat "cp blur_1.ps blur_"
			     i-string  ".ps"))
      
      (shell-command (concat "mogrify -blur "
			   i-string 
			   "x" i-string 
 			   " blur_" i-string ".ps"))
      (setq display-string (concat display-string " blur_" i-string ".ps "))
      (setq i (1+ i))
      )      ;; while
    
    (setq display-string (concat display-string "&"))
    (shell-command display-string)
    )    ;; let
  )    ;; progn

;;;; ** (2) 
 

;; Local Variables:
;; eval:(outline-minor-mode t)
;; outline-regexp:";;;; [*]+"
;; abbrev-mode:t
;; eval:(read-abbrev-file abbrev-file-name)
;;  End:
